[lisp] - selection set - jak przywrócić?


Recommended Posts

Prubuję uporac się z zaznaczeniami w lispie.

1. Wybieram zaznaczone elementy:

(vl-load-com)
(setq mh_CadObj (vlax-get-acad-object))
(setq mh_acd_doc (vla-get-activedocument mh_CadObj))
(setq mh_activselection (vla-get-ActiveSelectionSet mh_acd_doc))

2. wykonuje dalszą cześć funkcji w lispie

3. Chciałbym aby po wykonaniu polecenia przywrócić zaznaczenie. Da się to jakoś zrobić? Mógłby mnie ktoś nakierować, czego i gdzie szukać, jakiej funkcji użyć?

Link to comment
Share on other sites

Udzielił, musze tylko przemysleć sobie jak zrobić dobrze dwie funcje

1. zapamiętującą co jest aktualnie zaznaczone i czy czy wogule jest coś zaznaczone

2. przywracającą zaznaczenie o ile takie było

Dwie funkcje już Masz (i w sumie tylko tyle jest Ci potrzebne):

Zamienić zbiór wskazań na listę obiektów

;;--------------------------------=={ zk:SSZbr->List }==-----------------------------------;;
;;  Zamienia ss-grupę na listę z entity name                                               ;;
;;-----------------------------------------------------------------------------------------;;
;; ssZbr   [sSGET] - SS-group                                                              ;;
;;-----------------------------------------------------------------------------------------;;
(defun zk:SSZbr->List (ssZbr / % lista)
(repeat 
	(setq % (sslength ssZbr))
	(setq % (1- %) lista (cons (ssname ssZbr %) lista))
)
)

Zamienić listę na zbior wskazań

;;--------------------------------=={ zk:LST_SS->List }==-----------------------------------;;
; Ze zbioru SS-GET tworzy listę Entity Name                                                 ;;
;;------------------------------------------------------------------------------------------;;
(defun zk:LST_SS->List (sel / % l)
(repeat 
	(setq % (sslength sel))
	(setq % (1- %) 
		  l (cons (ssname sel %) l)
	)
)
)

a potem:

(sssetfirst nil ss)

Link to comment
Share on other sites

hmmm. Te dwie funkcje sa identyczne.

Teraz robota się zwaliła, wieczorkiem to dokładniej przeanalizuje.

hehe :)

faktycznie wkleiłem Ci tą samą funkcję dwukrotnie (starą wersję i nową) - sorrki :)

No ale tak czy siak, Masz już listę ename, więc utworzyć z niej z powrotem ss-group, to pikuś ;)

pozdrawiam

Link to comment
Share on other sites

mam tyle:

;=========================================================================
(defun c:aaa ()
(setq temp (zk:LST_SS->List (ssget)))
)

(defun c:bbb ()
(sssetfirst nil (mh:List->LST_SS temp))
;(mh:List->LST_SS temp)
)

;=========================================================================
; Ze zbioru SS-GET tworzy listę Entity Name
(defun zk:LST_SS->List (SSsel / % listEName)
   (repeat
       (setq % (sslength SSsel))
       (setq % (1- %)
             listEName (cons (ssname SSsel %) listEName)
       )
   )
)
;=========================================================================

;=========================================================================
; Ze listy Entity Name tworzy zbiór wskasań SSGet
(defun mh:List->LST_SS (listEName / % SSzbior)
   (setq SSzbior (ssadd))

(repeat
       (setq	% (vl-list-length listEName))
       (setq	% (1- %))
	(ssadd (nth % listEName) SSzbior)
   )
SSzbior
)
;=========================================================================

mysle nad wykozystaniem ssget bo vla-get-ActiveSelectionSet jakoś nie dam rady

Link to comment
Share on other sites

No właśnie się zastanawiałem dlaczego chcesz tutaj VisualLisp skoro SSGET z Lisp działa dobrze i szybciej :)

Dodatkowo zauważyłem błąd w ZwCAD:

przy kolejnym wywołaniu

(setq adoc (vla-get-activedocument(vlax-get-acad-object)))(vlax-for a (vla-get-activeselectionset adoc))

wyrzuca błąd i to bez względu na postać funkcji.

Po prostu VLA-GET-ACTIVESELECTIONSET albo nie czyści informacji w pamięci, albo wymaga dodatkowego ustawienia (w AC działa bez problemów).

błąd: *BŁĄD*

(VLA-GET-ACTIVESELECTIONSET ADOC)

(VLAX-FOR B (VLA-GET-ACTIVESELECTIONSET ADOC))

Link to comment
Share on other sites

Jeszcze jedna uwaga, zanim użyjesz funkcji vla-get-ActiveSelectionSet, to musisz sprawdzić czy jakiś zbiór istnieje, a jeśli nie, to go utworzyć np.

(setq ss (ssget "_x" '((0 . "INSERT") (66 . 1))))

Niemniej i tak występuje błąd w tej funkcji, co też zgłosiłem w odrębnym temacie.

pozdrawiam

Link to comment
Share on other sites

Mam juz i działa

;=========================================================================
(defun mh:SYS_GetSelection ()
;Zwraca listę Entity Name zaznaczonych obiektów lub nil jeżeli nic nie było zaznaczone
(if (not (= nil (ssget "I")))
	(zk:LST_SS->List (ssget "I"))
	nil
)
)
;=========================================================================

;=========================================================================
(defun mh:SYS_SetSelection ( listEN /)
;listEN - lista entity name
(if (not (= nil listEN))
	(sssetfirst nil (mh:List->LST_SS listEN))
)
)
;=========================================================================

;=========================================================================
; Ze zbioru SS-GET tworzy listę Entity Name
(defun zk:LST_SS->List (SSsel / % listEName)
   (repeat
       (setq % (sslength SSsel))
       (setq % (1- %)
             listEName (cons (ssname SSsel %) listEName)
       )
   )
)
;=========================================================================

;=========================================================================
; Ze listy Entity Name tworzy zbiór wskasań SSGet
(defun mh:List->LST_SS (listEName / % SSzbior)
   (setq SSzbior (ssadd))

(repeat
       (setq	% (vl-list-length listEName))
       (setq	% (1- %))
	(ssadd (nth % listEName) SSzbior)
   )
SSzbior
)
;=========================================================================

Wywołanie tego np. tak:

(setq MHSelMember (mh:SYS_GetSelection)) ;zaznaczenie elementów

(mh:SYS_SetSelection MHSelMember) ; przywrócenie zaznaczenia

Link to comment
Share on other sites

użyj tego

- przed uzyciem zaznacz elementy lub nie

(defun c:aaa ( / widok pozx pozy pozz MHSelMember)
(setq MHSelMember (mh:SYS_GetSelection))
;(mh:ustzap)


		(setq	widok (getvar "VIEWCTR")
				pozx (nth 0 widok)
				pozy (nth 1 widok)
				pozz (nth 2 widok)
				pozy (+ pozy 100.0))
		(command "_.zoom" "_c" (list pozx pozy pozz) "")



;(mh:ustprzywr) 
(mh:SYS_SetSelection MHSelMember)
);defun

Link to comment
Share on other sites

Mam w swojej nakładce funkcje która zmienia widok o określona wielkośc w lewo prawo itp.

Robiąc projekt budowlany budynku wielokondygnacyjnego muszę szybko przełączać widok między kondygnacjami. To juz miałem więc mogłem szybko sprawdzać czy na kondygnacjach pokrywaja sie szachty instalacyjne, kanalizacyjne itp.

Miałem tez funkcję do kopiowania o określoną odległość (czyli między kondygnacjami).

Teraz mogę przesuwając widok z kondygnacji na kondygnację zaznaczyć jakies elementy i np je skasować razem lub zrobić z nich blok lub grupę i przesuwać wspólnie na wszystkich pietrach.

Link to comment
Share on other sites

No to zatem powodzenia w dalszych działaniach :) Projekt rośnie w siłę.

Sprawdź przy okazji czy funkcją "_select" nie załatwiłbyś sprawy szybciej.

(setq ssOld (ssget "_x"))
... jakieś działania ...
(command "_select" ssOld "")
(setq ssNew (ssget "_p"))

Co prawda nazwa ss-grupy się zmieni, ale obiekty pozostają te same.

Można ją też wykorzystać w przypadku wyłapania nowych obiektów, w stosunku do poprzedniego wyboru np.

(setq ssOld (ssget "_x"))
... pojawiają się nowe obiekty ...
(setq ssNew (ssget "_x"))
(command "_select" ssNew "_r" ssOld "")   ;wyłapanie tylko nowo powstałych obiektów
(setq ssNew1 (ssget "_p"))

pozdrawiam

Link to comment
Share on other sites

Join the conversation

You can post now and register later. If you have an account, sign in now to post with your account.

Guest
Reply to this topic...

×   Pasted as rich text.   Paste as plain text instead

  Only 75 emoji are allowed.

×   Your link has been automatically embedded.   Display as a link instead

×   Your previous content has been restored.   Clear editor

×   You cannot paste images directly. Upload or insert images from URL.

Loading...
 Share